<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta name="description" content=""/>
    <meta name="keywords" content=""/>
    <title>ChatRoom</title>
    <link href="dist/img/favicon.png" type="image/png" rel="icon">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <meta name="apple-mobile-web-app-title" content="go聊天室">
    <!-- <link rel="apple-touch-icon" href="/dist/img/applogo144x144.png">   -->
    <!-- <link rel="manifest" href="/manifest.json"> -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css">
    <link rel="stylesheet" href="dist/css/perfect-scrollbar.min.css">
    <link rel="stylesheet" href="dist/css/themify-icons.css">
    <link rel="stylesheet" href="dist/css/emoji.css">
    <link rel="stylesheet" href="dist/css/style.css">
    <link rel="stylesheet" href="dist/css/responsive.css">
    <link rel="stylesheet" id="dark" href="dist/css/dark.css" disabled>
    <style>
        .modal-content {
            background-color: #fff;
        }
        .modal-content .form-control {
            display: block;
            width: 100%;
            height: calc(2.25rem + 2px);
            padding: .375rem .75rem;
            font-size: 1rem;
            line-height: 1.5;
            color: #495057;
            background-color: #fff;
            background-clip: padding-box;
            border: 1px solid #ced4da;
            border-radius: .25rem;
            transition: border-color .15s ease-in-out,box-shadow .15s ease-in-out;
        }
        .btn-primary {
            color: #fff;
            background-color: #007bff;
            border-color: #007bff;
        }
        .btn-secondary, .btn-secondary:hover {
            color: #fff;
            background-color: #5a6268;
            border-color: #545b62;
        }
    </style>
<!--    <link rel="stylesheet" href="dist/css/dark.css">-->
<!--    <link rel="stylesheet" href="dist/css/bootstrap.min.css">-->
<script src="https://www.gstatic.com/firebasejs/7.18.0/firebase-app.js"></script>
    <script src="https://www.gstatic.com/firebasejs/7.18.0/firebase-messaging.js"></script>
</head>
<body>
<main>
    <div class="layout">
        <div class="sidebar" id="sidebar">
            <div class="container">
                <div class="col-md-12">
                    <div class="tab-content">
                        <div class="list-group menu sort">
                            <button class="btn filterMenuBtn " id="friendLink" data-toggle="list" data-filter="friend">
                                <i class="ti-home"></i>
                                主頁
                            </button>
                            <button class="btn filterMenuBtn active show" id="chatLink" data-toggle="list" data-filter="chat">
                                <i class="ti-comment-alt"></i>
                                聊天
                            </button>

                            <button class="btn filterMenuBtn" data-toggle="modal" data-target="#login" title="Audio call" v-if="userName == ''">
                                登入
                            </button>
                            <button class="btn filterMenuBtn" title="Audio call" v-if="userName != ''"  @click="logout">
                                登出
                            </button>
                        </div>
                        
                            <div class="contacts filterMenu friend">
                                <div class="logo">
                                    <a class=" porfile" href="#">
                                        <img class="avatar-xl" :src="headImg" v-if="headImg !==''">
                                        {{ userName }}
                                        <i class="ti-panel"></i>
                                    </a>

                                </div>
                                <hr>
                                <div class="btn-group add-group" role="group">
                                    <button id="btnGroupDrop2" type="button" class="btn btn-default dropdown-toggle"
                                            data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        Add +
                                    </button>
                                    <div class="dropdown-menu" aria-labelledby="btnGroupDrop1">
                                        <a class="dropdown-item friendAdd" href="#">新增好友 +</a>
                                        <a class="dropdown-item groupAdd" href="#">新建群組 +</a>
                                    </div>
                                </div>
                                <!-- Start of Connections -->
                                好友
                                <div class="list-group  " id="contacts" role="tablist"  data-toggle="list">
                                    
                                    <a href="#"  data-toggle="list" class="contact filterDiscussions"
                                        :friendUserId="item.friendUserId" 
                                        v-for="(item, index) in friendList"
                                        @click="friendInfoWindow(item)"
                                    >
                                        <img class="avatar-md" :src="item.headImg" data-toggle="tooltip" data-placement="top" v-if="item.headImg !==''">
                                        <div class="data">
                                            <h5>{{item.username}}</h5>
                                        </div>
                                        <div class="person-add">
                                            <i class="ti-user"></i>
                                        </div>
                                    </a>
                                </div>
                                群組
                                <div class="list-group  ">
                                    <a href="#" class="contact filterDiscussions"
                                    id="list-chat-list" data-toggle="list" role="tab"
                                    v-for="(item, index) in roomListSort" 
                                    :roomId="item.roomId" :roomName="item.name" :type="item.type" class="chat" 
                                    v-if="item.type==2" @click="openGroupChatRoom(item)">
                                        <img class="avatar-md" :src=item.roomImg
                                          data-toggle="tooltip" data-placement="top" v-if="item.roomImg !==''" >
                                        <div class="data">
                                            <h5>{{ item.name }}</h5>
                                        </div>
                                        <div v-if="item.noReadCnt >0">
                                            <div class="new bg-red">
                                                <span>{{item.noReadCnt}}</span>
                                            </div>
                                        </div>
                                 </a>
                                </div>
                                <!-- End of Connections -->
                            </div>
                            
                            <div class="discussions filterMenu chat" >
                                <!-- <h1>Chats</h1> -->
                                <!-- <div class="btn-group add-group" role="group" style="right: 120px">
                                    <button type="button" class="dark-theme btn btn-default">
                                        <i class="ti-wand"></i>
                                        Night Mode
                                    </button>
                                </div> -->
                                
                                <div class="list-group" id="chats" role="tablist">
                                    <a href="#list-chat" class="filterDiscussions all unread single room"
                                       id="list-chat-list" data-toggle="list" role="tab"
                                       v-for="(item, index) in roomList" @click="openChatWindow"
                                       :roomId="item.roomId" :roomName="item.name" :type="item.type" class="chat">
                                        <img class="avatar-md" :src=item.roomImg
                                             data-toggle="tooltip" data-placement="top" v-if="item.roomImg !==''" >
                                        <div class="data">
                                            <h5>{{ item.name }}</h5>
                                        </div>
                                        <div v-if="item.noReadCnt >0">
                                            <div class="new bg-red">
                                                <span>{{item.noReadCnt}}</span>
                                            </div>
                                        </div>
                                    </a>
                                </div>
                            </div>
                        <!-- Start of Settings -->
                    </div>
                </div>
            </div>
        </div> <!-- Sidebar -->

        <div class="main" id="chat-dialog" :style="{ right: sidlerActive}">
            <div class="tab-content" id="nav-tabContent">
                <!-- Start of Babble -->
                <div class="babble tab-pane fade active show" id="list-chat" role="tabpanel"
                     aria-labelledby="list-chat-list">
                    <!-- Start of Chat -->
                    <div class="chat" id="chat1">
                        <div class="top">
                            <div class="container">
                                <div class="col-md-12">
                                    <div class="inside">
<!--                                        <div class="status online"></div>-->
                                        <div class="data">
                                            <h5><a href="#">{{ roomName }}</a>
                                            </h5>
                                            <h5 v-if="type==='2'">
                                                成員:
                                                <div  style="display:inline;" v-for="(item,index) in memberList[roomId]">{{item.userName}},</div>
                                                <button id="btnGroupDrop2" type="button" class="btn btn-default dropdown-toggle"
                                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                                    Add +
                                                </button>
                                                <div class="dropdown-menu" aria-labelledby="btnGroupDrop1" >
                                                    <a class="dropdown-item" data-toggle="modal" data-target="#memberAdd" href="#" >成員 +</a>
                                                    <a class="dropdown-item" data-toggle="modal" data-target="#memberDel" href="#" >成員 -</a>
                                                </div>
                                            </h5>
<!--                                            <span>Active now</span>-->
                                                
                                        </div>
                                        
                                        
                                        
                                        
                                        <button class="btn back-to-mesg" title="Back">
                                            <i class="ti-arrow-right"></i>
                                        </button>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="content" id="content">
                            <div class="container">
                                <div class="col-md-12">
                                    <div v-for="(item, index) in roomMessage">
                                        <div class="message me" v-if="item.userId == userId">
                                            <div class="text-main">
                                                <div class="text-group me">
                                                    <div class="text me">
                                                        <img :src=item.text alt="" v-if="item.text_kind == 100">
                                                        <audio controls  v-else-if="item.text_kind == 200">
                                                            <source :src=item.text type="audio/mpeg">
                                                          </audio>
                                                        <p v-html="item.text" v-else></p>
                                                    </div>
                                                    <div>
                                                        <p v-if="item.readCnt ==1">己讀</p>
                                                        <p v-else-if="item.readCnt >1">己讀{{item.readCnt}}</p>
                                                    </div>
                                                </div>
                                                <span>{{ item.timestamp }}</span>
                                            </div>
                                        </div>

                                        <div class="message" v-else>
                                                <img v-if="userImg[item.userId] !==undefined && userImg[item.userId] !==''"
                                                  class="avatar-md" :src=userImg[item.userId]
                                                data-toggle="tooltip" data-placement="top"  >
                                                    <span v-else>  {{userList[item.userId]}}</span>
                                                
                                            <div class="text-main">
                                                <div class="text-group">
                                                    <div class="text">
                                                        <img :src=item.text alt="" v-if="item.text_kind == 100">
                                                        <audio controls  v-else-if="item.text_kind == 200">
                                                            <source :src=item.text type="audio/mpeg">
                                                          </audio>
                                                        <p v-html="item.text" v-else></p>
                                                    </div>
                                                </div>
                                                <span>{{ item.timestamp }}</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div>
                           
                        </div>
                        <div class="container">
                            <div class="col-md-12">
                                <div class="bottom">
                                    <div class="text-area">
                                        <textarea id="message" class="form-control" placeholder="Start typing for reply..."
                                                  rows="1"></textarea>
                                        <button type="button" class="btn send send_message"><i class="ti-location-arrow"></i></button>
                                        
                                    </div>
                                    <label>
                                        <!-- 訊息列上傳檔案 -->
                                       <input type="file" multiple accept="image/jpeg,image/png,audio/*" name="multipleFile" id="file" @change="onFileUpload"/>
                                       <span class="btn attach"><i class="ti-clip"></i></span>
                                   </label> 
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- End of Chat -->
                </div>
                <!-- End of Babble -->
            </div>
        </div>
    </div> <!-- Layout -->

    <div class="modal fade" id="login" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">登入</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group roomName">
                        <label>帳號:</label>
                        <br><br>
                        <input id="userName" type="text" class="form-control" placeholder="帳號" v-model="username">
                    </div>
                    <div class="form-group">
                        <label>密碼:</label>
                        <br><br>
                        <input id="pwd" type="text" class="form-control" placeholder="密碼" v-model="password">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">關閉</button>
                    <button type="button" class="btn btn-primary" @click="login">登入</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="roomAdd" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">搜尋聯絡人</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group roomName">
                        <label>房間名稱:</label>
                        <br><br>
                        <input type="text" class="form-control" id="roomName">
                    </div>
                    <div class="form-group">
                        <label>聯絡人:</label>
                        <br><br>
                        <input type="text" class="form-control" id="id">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary search">Create</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="profileEdit" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">修改個人資料</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>個人頭像:</label>
                        <br><br>
                        <input type="file" multiple accept="image/jpeg,image/png," name="multipleFile" id="profileUp" @change="onProFileUpload"/>
                        <!-- <input type="text" class="form-control" id="profileImg"> -->
                    </div>
                </div>
                <!-- <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary search">Create</button>
                </div> -->
            </div>
        </div>
    </div>

     <!-- id:friendAdd 點擊add+ 開啟視窗 可搜尋帳號 新增好友 判斷是否己為好友、本人 -->
    <div class="modal fade" id="friendAdd" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">新增好友</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-inline">
                        <div class="form-group">
                            <label>帳號:</label>
                            <br><br>
                            <input type="text" class="form-control" id="member">
                            <button class="search_account"><img src="dist/img/search.svg">搜尋</button>
                        </div>
                    </div>
                    
                    <div id="search_result" v-if="Object.keys(searchAccResult).length >0">
                        <div v-if=" searchAccResult.userId >0" class="profile">
                            <img class="avatar-xxl" :src=searchAccResult.headImg v-if="searchAccResult.headImg !==''">
                            <div class="data">
                                <h5>{{searchAccResult.username}}</h5>
                            </div>
                            <div v-if="!searchAccResult.isOld">
                                <button type="button" class="btn btn-primary add_friend" @click="addFriend">新增好友</button>
                            </div>
                            <div v-else-if="searchAccResult.tipText !==null">
                                <h5>{{searchAccResult.tipText}}</h5>
                            </div>
                        </div>
                        <div v-else>
                            <h5>帳號搜尋無此人</h5>
                        </div>
                       
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="memberAdd" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">搜尋聯絡人</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>聯絡人:</label>
                        <br><br>
                        <input type="text" class="form-control" id="memberAddText">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary search_member">新增</button>
                </div>
            </div>
        </div>
    </div>

    <div class="modal fade" id="memberDel" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">搜尋聯絡人</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="form-group">
                        <label>聯絡人:</label>
                        <br><br>
                        <input type="text" class="form-control" id="member_minus">
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                    <button type="button" class="btn btn-primary del_member">移除成員</button>
                </div>
            </div>
        </div>
    </div>

    <!-- 任意點擊好友 開啟新的 好友資訊視窗 可開聊天、刪除好友 -->
    <div class="modal fade" id="friendInfo" tabindex="-1" role="dialog" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">好友資訊</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div id="friendDetail" >
                        <div  class="profile">
                            <img class="avatar-xxl" :src=nowFriend.headImg v-if="nowFriend.headImg !==''">
                            <div class="data">
                                <h5>{{nowFriend.username}}</h5>
                            </div>
                        </div>
                        <div>
                            <button type="button" class="btn btn-secondary" data-dismiss="modal" @click="openChatRoom">聊天</button>
                            <button type="button" class="btn btn-secondary" data-dismiss="modal" @click="delFriend">刪除</button>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

</main>
 <!-- Insert these scripts at the bottom of the HTML, but before you use any Firebase services -->

<script src="dist/js/jquery3.3.1.js"></script>
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
<script src="dist/js/vendor/popper.min.js"></script>
<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin="anonymous"></script>
<script src="dist/js/perfect-scrollbar.min.js"></script>
<script src="dist/js/script.js"></script>
<script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/axios/0.19.2/axios.min.js"></script>
<script>
    // console.log = function(){}
    // Your web app's Firebase configuration
    var firebaseConfig = {
        apiKey: "AIzaSyAWYjPoPGkZejt42hItU3aAG9BooOaeTUQ",
        authDomain: "gochat-509a1.firebaseapp.com",
        databaseURL: "https://gochat-509a1.firebaseio.com",
        projectId: "gochat-509a1",
        storageBucket: "gochat-509a1.appspot.com",
        messagingSenderId: "669448722616",
        appId: "1:669448722616:web:4a459e47400c9035fa3c4d",
        measurementId: "G-WHWNLLZ011"
    };
    // Initialize Firebase
    firebase.initializeApp(firebaseConfig);
   

    if (firebase.messaging.isSupported()){
        // Get the Messaging service for the default app
        var defaultMessaging = firebase.messaging();
        
        defaultMessaging.onMessage(payload => {
            const { title, ...options } = payload.notification;

            var notify = new Notification('聊天室' , {
                body: '有新的訊息...',
            });
        });
    }
    
    function timeStamp2String(time) {
        // Convert timestamp to milliseconds
        var date = new Date(time * 1000);

        // Year
        var year = date.getFullYear();

        // Month
        var month = date.getMonth() + 1;

        // Day
        var day = date.getDate();

        // Hours
        var hours = date.getHours();

        // Minutes
        var minutes = "0" + date.getMinutes();

        // Seconds
        var seconds = "0" + date.getSeconds();

        // Display date time in MM-dd-yyyy h:m:s format
        return year + "-" + month + "-" + day + " " + hours + ":" + minutes.substr(-2) + ":" + seconds.substr(-2);
    }

    function nl2br(str, is_xhtml) {
        if (typeof str === 'undefined' || str === null) {
            return '';
        }
        var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '<br />' : '<br>';
        return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
    }

    function contentToButtom() {
        $("#content").scrollTop(0);
        window.setTimeout(function () {
            $("#content").scrollTop($("#content")[0].scrollHeight);
        }, 100);
    }

    function getDefaultData() {
        return {
            username: '',
            password: '',
            userName: '',
            userId: '',
            headImg:'',
            roomId: '',
            roomName: '',
            type: '',
            friendList: [],
            roomList: [],
            memberList:[],
            userList: [],
            userImg: [],
            messageList: [],
            roomMessage: [],
            roomMessageRead:[],
            nowFriend:{},
            searchAccResult:{},
            sidlerActive:'',
            token: '',
            file:'',
        }
    }

    var host = "124.108.169.162:8001";
    // var host = "192.168.0.110:8001";
    var ws;
    let app = new Vue({
        el: 'main',
        data: getDefaultData(),
        methods: { //methods是關鍵字
            logout(){
                ws.close();
                sessionStorage.removeItem('userName');
                sessionStorage.removeItem('token');
                sessionStorage.removeItem('userId');
                sessionStorage.removeItem('messageList');
                sessionStorage.removeItem('roomList');
                sessionStorage.removeItem('userList');
                sessionStorage.removeItem('headImg');
                app.reset();
            },
            login() {
                $.ajax({
                    url: "http://"+host+"/php-chat/public/user/login",
                    method: "post",
                    data: {
                        username: this.username,
                        password: this.password
                    },
                    success: function (response) {
                        if (response.statusCode == '0' ||  response.statusCode == 0) {
                            var newHeaimg = response.data.headImg
                            var originImg = response.data.headImg.split(',')
                            
                            if (originImg.length ===3){
                                newHeaimg = originImg[0]+';'+originImg[1]+','+originImg[2]
                            }
                            
                            app.token = response.data.token;
                            app.userName = app.username;
                            app.userId = response.data.userId;
                            app.headImg= newHeaimg;
                            
                            sessionStorage.setItem('token', app.token);
                            sessionStorage.setItem('userName', app.username);
                            sessionStorage.setItem('userId', app.userId);
                            sessionStorage.setItem('headImg', app.headImg);

                            $("#login").modal('hide');
                            $("#chatLink").click()

                            app.webSocket()
                            app.getFriend()
                            if (firebase.messaging.isSupported()){
                                app.grantNotifition()
                            }
                            // alert('登入成功');
                        } else {
                            alert(response.message);
                        }
                        // handle success
                    }
                });
            },
            sendFireBaseTokenSave(device){
                if (!device) {
                    return
                }
                $.ajax({
                    url: "http://"+host+"/auth/google/fcm/device",
                    method: "post",
                    headers: {
                        Authorization: 'Bearer '+app.token,
                    },
                    data: {
                        deviceToken: device,
                        deviceType:1,
                    },
                    success: function (response) {
                        if (response.statusCode == '0' ||  response.statusCode == 0) {
                            console.log(response.message)
                        } 
                    }
                });
            },
            grantNotifition(){
                defaultMessaging
                .requestPermission()
                    .then(() => {
                        return defaultMessaging.getToken();
                    })
                    .then(token => {
                        this.sendFireBaseTokenSave(token)
                    })
                    .catch(err => {
                        console.log("No permission to send push", err);
                });
            },
            getFriend() {
                $.ajax({
                    url: "http://"+host+"/auth/friend",
                    method: "get",
                    headers: {
                        Authorization: 'Bearer '+app.token,
                    },
                    success: function (response) {
                        if (response.statusCode === 0) {
                            app.friendList = response.data
                            app.friendList.forEach(function(item,index,array){
                                var newHeaimg = item.headImg
                                var originImg = item.headImg.split(',') 
                                if (originImg.length ===3){
                                    newHeaimg = originImg[0]+';'+originImg[1]+','+originImg[2]
                                    app.friendList[index].headImg = newHeaimg
                                }
                                if (!app.userImg[item.friendUserId]){
                                    app.userImg[item.friendUserId] = newHeaimg
                                }
                            })
                        } 
                        // handle success
                    }
                });
            },
            webSocket() {
                
                ws = new WebSocket('ws://'+host+'/ws?token=' + app.token);
                // ws = new WebSocket('ws://localhost:8001?token=' + app.token);
                ws.onopen = function () {
                    let roomList = sessionStorage.getItem('roomList');
                    // console.log('websocket on open')
                    // if (roomList == null) {
                        var params = {
                            action: 'roomList',
                            userId: app.userId,
                        }
                        ws.send(JSON.stringify(params));
                    // } 
                    // else {
                    //     app.roomList = JSON.parse(roomList);

                    //     let userList = sessionStorage.getItem('userList');
                    //     if (userList != null) {
                    //         app.userList = JSON.parse(userList);
                    //     }

                    //     let messageList = sessionStorage.getItem('messageList');
                    //     if (messageList != null) {
                    //         app.messageList = JSON.parse(messageList);
                    //     }

                    //     window.setTimeout(function () {
                    //         $('.room').eq(0).trigger('click')
                    //     }, 100);
                    // }
                    window.setInterval(function () {
                        var params = {
                            action: "ping",
                        }
                        ws.send(JSON.stringify(params));
                    }, 58000)
                };
                ws.onmessage = function (e) {
                    // console.log(e.data);
                    message = JSON.parse(e.data);
                    let data = message.data;
                    switch  (message.statusCode){
                        case 2010: 
                            window.setTimeout(function () {
                                $.each(data.rooms, function (k, v) {
                                    if (app.messageList[v.roomId] === undefined) {
                                        //取得房間訊息
                                        var params = {
                                            action: 'roomMessage',
                                            roomId: v.roomId,
                                            timestamp: 0
                                        }
                                        ws.send(JSON.stringify(params));
                                        //取得房間內容
                                        var params = {
                                            action: 'roomDetail',
                                            roomId: v.roomId,
                                        }
                                        ws.send(JSON.stringify(params));
                                        app.messageList[v.roomId] = [];
                                        sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                                    } else {
                                        $.each(v.message, function (key, val) {
                                            
                                            $.each(app.roomList, function (key, val) {
                                                if (val.roomId == v.roomId && parseInt(app.roomId) !== v.roomId) {
                                                    app.roomList[key].noReadCnt =  app.roomList[key].noReadCnt +1;
                                                    app.roomList[key].lasttime = Date.now();
                                                }
                                            });
                                            //己讀
                                            if (parseInt(app.roomId) === v.roomId) {
                                                messageIds =[val.messageId]
                                                app.roomMessageRead[app.roomId] = val.messageId
                                                var params = {
                                                    roomId:parseInt(app.roomId),
                                                    messageIds: messageIds,
                                                    action: 'readMessage',
                                                }
                                                
                                                ws.send(JSON.stringify(params));
                                            }
                                        });
                                        
                                        // sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                                    }
                                });
                            }, 2000);
                            break;
                        case 2011: 
                       
                            //接收訊息
                            app.messageList[data.roomId].push({
                                userId: data.userId,
                                text_kind:data.kind,
                                text: data.message,
                                messageId: data.messageId,
                                readCnt:0,
                                timestamp: timeStamp2String(data.timestamp),
                            });
                            sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                            contentToButtom();
                            if (parseInt(app.roomId) === data.roomId) {
                                messageIds =[data.messageId]
                                app.roomMessageRead[app.roomId] = data.messageId
                                var params = {
                                    roomId:parseInt(app.roomId),
                                    messageIds: messageIds,
                                    action: 'readMessage',
                                }
                                ws.send(JSON.stringify(params));
                            } else {
                                $.each(app.roomList, function (key, val) {
                                    if (val.roomId == data.roomId) {
                                        app.roomList[key].noReadCnt =  app.roomList[key].noReadCnt+1;
                                        app.roomList[key].lasttime = Date.now();
                                    }
                                });
                                
                            }

                            break;
                        case 2012:
                            app.roomList= []
                            //房間列表
                            $.each(message.data.rooms, function (k, v) {
                                app.roomList.push({roomId: v.roomId, type: v.type, name: v.name,noReadCnt:0,roomImg:'',lasttime:0});
                                //取得房間內容
                                var params = {
                                    action: 'roomDetail',
                                    roomId: v.roomId,
                                }
                                ws.send(JSON.stringify(params));
                                //取得房間訊息
                                var params = {
                                    action: 'roomMessage',
                                    roomId: v.roomId,
                                    timestamp: 0
                                }
                                ws.send(JSON.stringify(params));
                                app.messageList[v.roomId] = [];
                            });
                            sessionStorage.setItem('roomList', JSON.stringify(app.roomList));
                            window.setTimeout(function () {
                                $('.room').eq(0).click()
                            }, 300);
                        break;
                        case 2013:
                            //房間明細
                            if (data.type == 1) {
                                $.each(data.members, function (k, v) {
                                    var newHeaimg = v.headImg
                                    var originImg = v.headImg.split(',') 
                                    if (originImg.length ===3){
                                        newHeaimg = originImg[0]+';'+originImg[1]+','+originImg[2]
                                    }

                                    app.userList[v.userId] = v.userName;
                                    app.userImg[v.userId] = newHeaimg;
                                    if (v.userName.toLowerCase() != app.userName.toLowerCase()) {
                                        $.each(app.roomList, function (key, val) {
                                            if (val.roomId != data.roomId) {
                                                return;
                                            }
                                            app.roomList[key].roomImg = newHeaimg
                                            app.roomList[key].name = v.userName;
                                        });
                                    }
                                });
                            } else {
                                $.each(data.members, function (k, v) {
                                    app.userList[v.userId] = v.userName;
                                });
                                var exist = 0;
                                $.each(app.roomList, function (key, val) {
                                    if (val.roomId == data.roomId) {
                                        exist = 1;
                                    }
                                });
                                if (!exist) {
                                    app.roomList.push({roomId: data.roomId, type: data.type, name: data.name,noReadCnt:0,roomImg:data.roomImg,lasttime:0});
                                }
                            }
                            
                            app.memberList.splice(data.roomId,1);
                            
                            app.memberList[data.roomId] = data.members
                            
                            sessionStorage.setItem('userList', JSON.stringify(app.userList));
                            sessionStorage.setItem('roomList', JSON.stringify(app.roomList));
                        break;
                        case 2014:
                            //所有訊息
                            app.messageList[data.roomId] = [];
                            $.each(data.messages, function (k, v) {
                                app.messageList[data.roomId].push({
                                    userId: v.userId,
                                    text_kind:v.text_kind,
                                    text: nl2br(v.text),
                                    messageId: v.messageId,
                                    readCnt:0,
                                    timestamp: timeStamp2String(v.timestamp),
                                });
                            });
                            sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                        break;
                        case 2015:
                            var roomId = data.roomId;
                            
                            //建立私聊
                            //檢查房間是否存在
                            if (app.messageList[roomId] !== undefined) {
                                $('#roomAdd').modal('hide');
                                $('#chatLink').click()
                                $('.room[roomId="' + roomId + '"]').click()
                                app.openChatWindow()
                                return false;
                            }

                            
                            
                            $.each(data.members, function (k, v) {
                                if (v.userName.toLowerCase() == app.userName.toLowerCase()) {
                                    return;
                                }
                                app.roomList.push({roomId: roomId, type: 1, name: v.userName,noReadCnt:0,roomImg:'',lasttime:0});
                            });
                            //取得房間內容
                            var params = {
                                action: 'roomDetail',
                                roomId: roomId,
                            }
                            ws.send(JSON.stringify(params));
                            app.messageList[roomId] = [];
                            if (data.roomName.toLowerCase() !== app.userName.toLowerCase()) {
                                $('#roomAdd').modal('hide')
                                $('#chatLink').click()
                            
                            
                                window.setTimeout(function () {
                                    $('.room[roomId="' + roomId + '"]').click();
                                }, 300);
                            }
                            app.openChatWindow()
                            sessionStorage.setItem('roomList', JSON.stringify(app.roomList));
                            sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                        break;
                        case 2016:
                            var roomId = data.roomId;
                            
                            //建立群聊
                            app.roomList.push({roomId: roomId, type: 2, name: data.roomName,noReadCnt:0,roomImg:'',lasttime:Date.now()});
                            var params = {
                                action: 'roomMessage',
                                roomId: roomId,
                                timestamp: 0
                            }
                            app.messageList[roomId] = [];
                            $('#roomAdd').modal('hide')
                            $('.room[roomId="' + roomId + '"]').trigger("click");
                            sessionStorage.setItem('roomList', JSON.stringify(app.roomList));
                            sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                        break;
                        case 2017:
                            var roomId = data.roomId;
                            var roomName= data.name;
                            
                            $.each(data.addMembers, function (k, v) {
                                if (v.userName.toLowerCase() == app.userName.toLowerCase()) {
                                    //建立群組
                                    app.roomList.push({roomId: roomId, type: 2, name: roomName,noReadCnt:0,roomImg:'',lasttime:Date.now()});
                                
                                    //取得房間訊息
                                    var params = {
                                        action: 'roomMessage',
                                        roomId: roomId,
                                        timestamp: 0
                                    }
                                    ws.send(JSON.stringify(params));
                                    app.messageList[roomId] = [];
                                }
                            });
                            //取得房間內容
                            var params = {
                                action: 'roomDetail',
                                roomId: roomId,
                            }
                            ws.send(JSON.stringify(params));
                            $('#memberAdd').modal('hide')
                        break;
                        case 2018:
                       
                        var roomId = data.roomId;
                        var roomName= data.roomName;
                        var isRemove = false;    
                            $.each(data.delMembers, function (k, v) {
                                // console.log('2018',v.userName.toLowerCase(),app.userName.toLowerCase())
                                if (v.userName.toLowerCase() == app.userName.toLowerCase()) {
                                    isRemove = true
                                    //建立群組
                                    app.roomList = app.roomList.filter(function(item,index,array){
                                        return roomId !==item.roomId
                                    })
                                }
                            });
                            if (!isRemove){
                                //取得房間內容
                                var params = {
                                    action: 'roomDetail',
                                    roomId: roomId,
                                }
                                ws.send(JSON.stringify(params));
                            }
                            $('#memberDel').modal('hide')
                        break;
                        case 2020:
                            
                            $.each(data.messages, function (k, v) {
                                app.messageList[data.roomId].forEach(function(item,index,array ) { 
                                    if (item.messageId === v.messageId) {
                                        item.readCnt=v.readCount;
                                    }
                                });
                            })
                            sessionStorage.setItem('messageList', JSON.stringify(app.messageList));
                            contentToButtom();
                        break;
                        case 2031:
                            //個人資料更新
                            data.profile.forEach(function(item,index,array){
                                var newHeaimg = item.headImg
                                var originImg = item.headImg.split(',') 
                                if (originImg.length ===3){
                                    newHeaimg = originImg[0]+';'+originImg[1]+','+originImg[2]
                                }
                                if(item.userId ===  parseInt(app.userId)){
                                    app.headImg = newHeaimg
                                    sessionStorage.setItem('headImg', newHeaimg);
                                }
                                
                                app.userImg[item.userId] = newHeaimg
                                app.friendList.forEach(function(friendItem,friendIndex,friendArray){
                                    if (friendItem.friendUserId === item.userId){
                                        friendItem.headImg = newHeaimg
                                    }
                                 })  
                            })
                            
                            $('#profileEdit').modal('hide')
                        break;
                        default:
                    } 
                };

                ws.onclose = function (event) {
                    // console.log("WebSocket is closed now.");
                    app.logout();
                };
            },
            reset() {
                Object.assign(app.$data, getDefaultData());
            },
            onProFileUpload(){
                var profileImg = document.getElementById('profileUp').files[0];
                const toBase64 = file => new Promise((resolve, reject) => {
                    const reader = new FileReader();
                    reader.readAsDataURL(file);
                    reader.onload = () => resolve(reader.result);
                    reader.onerror = error => reject(error);
                });
               toBase64(profileImg).then(data=>{
                //    imgBase64 = data.split(',')
                   var params = {
                            action: 'updateProfile',
                            headImg: data,
                        }
                        ws.send(JSON.stringify(params));
               })
                
            },
            onFileUpload(){
                var formData = new FormData();
                var imagefile = document.getElementById('file');
                var config = {headers:{'Content-Type': 'multipart/form-data'}};
                
                formData.append("file", imagefile.files[0]);
                axios.post("http://"+host+"/uploadFile",formData,config)
                .then(function(resp){
                    if (resp.data.statusCode !==0){
                            alert(resp.data.message)
                        return
                    }
                    if (app.roomId > 0) {
                        var params = {
                            action: 'sendMessage',
                            kind:100,
                            roomId: parseInt(app.roomId),
                            message: resp.data.data.path,
                        }
                        ws.send(JSON.stringify(params));
                    } else {
                        console.log('請先選擇聊天對象')
                    }
                })
            },
            addFriend(){
                    var formData = new FormData();
                    var config = {headers:{
                        'Content-Type': 'multipart/form-data',
                        'Authorization': 'Bearer '+app.token,
                    }};
                    
                    formData.append("friendUserId", app.searchAccResult.userId);
                    
                    axios.post( "http://"+host+"/auth/friend",formData,config).then(function(response){
                        if (response.data.statusCode === 0) {
                            app.searchAccResult.isOld = true
                            alert('新增成功')
                            app.getFriend()
                        } 
                    });
            },
            openChatWindow(){
                app.sidlerActive = '0'
            },
            friendInfoWindow(item){
                $('#friendInfo').modal()
                app.nowFriend = item
            },
            openChatRoom(){
               //新增私聊或進入私聊視窗
                var params = {
                    action: 'createPersonalRoom',
                    userId: parseInt(app.nowFriend.friendUserId)
                }
                // console.log(params);
                ws.send(JSON.stringify(params));
            },
            openGroupChatRoom(item){
                var roomId=item.roomId;
                // console.log(roomId)
                $('#chatLink').click();
                $('.room[roomId="' + roomId + '"]').click();
                app.openChatWindow()
            },
            delFriend(){
                var formData = new FormData();
                var config = {headers:{
                    'Content-Type': 'multipart/form-data',
                    'Authorization': 'Bearer '+app.token,
                }};
                
                formData.append("friendUserId", parseInt(app.nowFriend.friendUserId));
                
                axios.post( "http://"+host+"/auth/friend/del",formData,config).then(function(response){
                    if (response.data.statusCode === 0) {
                        app.searchAccResult.isOld = true
                        alert('刪除成功')
                        app.getFriend()
                        $('#friendInfo').hide()
                    } 
                });
            },
            sortKey(array,key){
                return array.sort(function(a,b){
                var x = a[key];
                var y = b[key];
                return ((x>y)?-1:(x<y)?1:0)
                })
            }
        },
    computed:{
     roomListSort:function(){
      return this.sortKey(this.roomList,'lasttime')
     }
    },
    mounted: function () {
            $("#message").keypress(function (e) {
                if (e.which == 13 && !e.shiftKey) {
                    if ($("#message").val() != '') {
                        $(".send_message").trigger('click');
                    }
                    return false;
                }
            });

            //顯示 新增好友視窗
            $('.friendAdd').click(function () {
                //進入前 先將結果清空
                app.searchAccResult = {}
                $('#friendAdd').modal();
            });

            $('.personalAdd').click(function () {
                $('.roomName').hide();
                $('#roomAdd').modal();
            });
            $('.groupAdd').click(function () {
                $('.roomName').show();
                $('#roomAdd').modal();
            });
            $('.porfile').click(function(){
                $('#profileEdit').modal();
            })

            //聊天視窗 返迴列表
            $("body").on('click', '.back-to-mesg', function () {
                app.sidlerActive = '-100%'
            });

            //點擊聊天室
            $("body").on('click', '.room', function () {
                $('#message').attr('disabled', false);
                app.roomId = $(this).attr("roomId");
                app.roomName = $(this).attr("roomName");
                app.type = $(this).attr("type");
                app.roomMessage = app.messageList[app.roomId];
                messageIds =[]
                if (app.roomMessageRead[app.roomId] === undefined){
                    app.roomMessageRead[app.roomId] = 0
                }
                
                $.each(app.roomList, function (key, val) {
                    if (val.roomId == app.roomId) {
                        app.roomList[key].noReadCnt =  0;
                    }
                });
                $.each(app.roomMessage, function (k, v) {
                    if (v.messageId >= app.roomMessageRead[app.roomId]) {
                        messageIds.push( v.messageId);
                        app.roomMessageRead[app.roomId] = v.messageId
                    }
                });
                var params = {
                    roomId:parseInt(app.roomId),
                    messageIds: messageIds,
                    action: 'readMessage',
                }
                ws.send(JSON.stringify(params));
                contentToButtom()
            });

            $('.send').click(function () {
                if (app.roomId > 0) {
                    var params = {
                        action: 'sendMessage',
                        roomId: parseInt(app.roomId),
                        message: $('#message').val(),
                    }
                    ws.send(JSON.stringify(params));
                    $('#message').val('');
                } else {
                    alert('請先選擇聊天對象')
                }
            });


            $('.search').click(function () {
                //群聊要輸入
                if ($('#roomName').is(':visible') && $('#roomName').val() == '') {
                    alert('請輸入房間名稱');
                    return false;
                }
                $.ajax({
                    url: "http://"+host+"/php-chat/public/user/search/" + $('#id').val(),
                    // url: "http://localhost:8001/php-chat/public/user/search/" + $('#id').val(),
                    method: "GET",
                    success: function (response) {
                        // console.log(response)
                        if (response.data.userId !== undefined) {
                            if ($('#roomName').is(':visible')) {
                                //群聊
                                var params = {
                                    action: 'createGroupRoom',
                                    roomName: $('#roomName').val(),
                                    members: [response.data.userId]
                                }
                                ws.send(JSON.stringify(params));
                            } else {
                                //私聊
                                var params = {
                                    action: 'createPersonalRoom',
                                    userId: response.data.userId
                                }
                                ws.send(JSON.stringify(params));
                            }
                        } else {
                            alert('找不到聯絡人');
                        }
                    }
                });
            });

            

            //搜尋好友
            $('.search_account').click(function () {
                // console.log('search_account')
                $.ajax({
                    url: "http://"+host+"/php-chat/public/user/search/" + $('#member').val(),
                    method: "GET",
                    success: function (response) {
                        if (response.data.userId !== undefined) {
                           app.searchAccResult = response.data

                           //安卓圖片上傳以逗號分隔
                            var newHeaimg = response.data.headImg
                            var originImg = response.data.headImg.split(',') 
                            if (originImg.length ===3){
                                app.searchAccResult.headImg = originImg[0]+';'+originImg[1]+','+originImg[2]
                            }
                        }
                        // console.log(response.data.username,app.usernName)
                        //判斷搜尋是否為本人帳號
                        if (response.data.username === app.userName){
                            app.searchAccResult.isOld = true
                            app.searchAccResult.tipText = '搜尋本人?'
                        }
                        app.friendList.forEach(function(item,index,array ) { 
                            if (item.username === $('#member').val()) {
                                app.searchAccResult.isOld = true
                                app.searchAccResult.tipText = '己在好友列表'
                            }
                        }); 
                    }
                });
            });

            $('.search_member').click(function () {
                $.ajax({
                    url: "http://"+host+"/php-chat/public/user/search/" + $('#memberAddText').val(),
                    method: "GET",
                    success: function (response) {
                        if (response.data.userId !== undefined) {
                            var params = {
                                action: 'addGroupMember',
                                roomId: parseInt(app.roomId),
                                members: [response.data.userId]
                            }
                            ws.send(JSON.stringify(params));
                        } else {
                            alert('找不到聯絡人');
                        }
                    }
                });
            });

            $('.del_member').click(function () {
                $.ajax({
                    url: "http://"+host+"/php-chat/public/user/search/" + $('#member_minus').val(),
                    // url: "http://localhost:8001/php-chat/public/user/search/" + $('#member').val(),
                    method: "GET",
                    success: function (response) {
                        // console.log(response)
                        if (response.data.userId !== undefined) {
                            var params = {
                                action: 'removeGroupMember',
                                roomId: parseInt(app.roomId),
                                members: [response.data.userId]
                            }
                            ws.send(JSON.stringify(params));
                        } else {
                            alert('找不到聯絡人');
                        }
                    }
                });
            });

            //有token直接登入
            window.setTimeout(function () {
                if (sessionStorage.getItem('token') != null) {
                    app.token = sessionStorage.getItem('token');
                    app.userName = sessionStorage.getItem('userName');
                    app.userId = sessionStorage.getItem('userId');
                    app.headImg = sessionStorage.getItem('headImg');
                    app.webSocket();
                    app.getFriend();
                } else {
                    $('#login').modal();
                }
            }, 100)

            $(".filterMenu").not(".chat").hide("3000")
            //切換tab
            $(".filterMenuBtn").on("click", function () {
                var t = $(this).attr("data-filter");

                $(".filterMenu").not("." + t).hide("3000"),
                $(".filterMenu").filter("." + t).show("3000");
            })
            

        }
    });
</script>
</body>
</html>